import java.util.Random;
/**
 * Class SelSortRec fills and sorts double array a.
 * 
 * @author RR
 * @version 2002/11/17
 */
public class SelSortRec
{
    private int theLength;
    private double[] a;

/**
 * Constructor
 * 
 * @param asize length of array
*/
    public SelSortRec(int asize) 
    { 
       theLength = asize;
       a = new double[theLength];
    }
     
    public void fill()
    {    
       Random generator = new Random(); 
       for (int i = 0; i < a.length; i++) 
       { 
         a[i] = generator.nextDouble(); 
       }
     }
     
    public void printOut()
    {    
       for (int i = 0; i < a.length; i++) 
       { 
         System.out.println(a[i]); 
       }
       System.out.println();
     }
     
    /**
     * sortRec
     * 
     * implements selection sort recursively:
     * the first sortRec does the sort recursively
     * the second takes a call
     * 
     */
    public void sortRec(double[] a, int lo, int hi)
    {
      if (lo < hi) // subarray has more than 1 element
      {
         swap(a,lo,findMinimum(a,lo,hi));
         sortRec(a, lo+1, hi);
       }
    }

    public void sortRec()
    {
       sortRec(a, 0, a.length-1);
    }
    
    
    /**
     * findMinimum
     * 
     * @param  a   a double array
     * @param  lo  the lower position in a
     * @param  hi  the upper position in a
     * 
     * @return locationOfMinimum position of the minimum value 
     */
    private int findMinimum(double[] a, int lo, int hi)
    {
        // 
        if (lo == hi)
            return lo;
        else
        {
            int locationOfMinimum = findMinimum(a, lo+1, hi);
            if( a[lo] < a[locationOfMinimum] )
                return lo;
            else
                return locationOfMinimum;
         }
    }
    /**
     * 
     * Swap
     * 
     * @param a   double array
     * @param i,j the positions to swap
     * 
     */
    private void swap(double[] a, int i, int j)
    {
        double temp = a[i];
        a[i] = a[j];
        a[j] = temp;
    }
    
} 
